/*              FUNC4.C

		Demonstration of multiple function calls, returning FLOAT types .*/



#include <stdio.h>

float average(),largest(),smallest();	/* declare functions */

void main()
{
float a[10];
int i;

printf("\n\nEnter 10 numbers and I will compute the minima, maxima,\
and average\n\n");

for(i=0;i<10;i++)
				{
				printf("Number #%d ?",i+1);
				scanf("%f",&a[i]);
				}

//
// Note how we just pass "a." That looks a little strange, but
// what we're really passing is the ADDRESS of the array (which
// is much more efficient than passing the ENTIRE array!)
//

printf("\n\nThe maxima is %f\n",largest(a));
printf("The minima is %f\n",smallest(a));
printf("The average is %f\n",average(a));

}


//
// Note how the array is declared in this function, then compare
// it to the next function's declaration.
//

float largest(float a[])
{
float temp;
int i;

temp=a[0];

for(i=1;i<10;i++)
			if (a[i]>temp)	temp=a[i];

return(temp);
}

//
// The declaration "float* a" has EXACTLY the same meaning to the
// C compiler as "float a[]" in the previous function. It
// emphasizes that arrays are passed to functions by address
// (pointer), not value.
//

float smallest(float* a)
{
float temp;
int i;

temp=a[0];

for(i=1;i<10;i++)
			if (a[i]<temp)	temp=a[i];

return(temp);
}



float average(float a[])
{
float temp;
int i;

temp=0;

for(i=0;i<10;i++)
			temp=temp+a[i];

return(temp/10);
}

