/*                     POINT2.C

	This is an example of sending a pointer to a variable to a function. */

#include <stdio.h>



//
// Function to which we'll pass values by POINTER
//
//
// NOTE how every pointer (except for a void pointer) always
// points to a particular data type. The compiler MUST know
// what the data type of a pointer is in order to work with it.
//

void sendit(int* var,float* apple)
{

printf("SENDIT() modifying the values.\n");
*var = *var + 10;	// Adds 10 to the INT value at *var

*apple=*apple+20;	// Adds 20 to the FLOAT value at *apple
}


//
// Main Program
//


void main()
{
int a;		/* Read as "A is an INT" */
int* prt;	/* Read as "PTR is a POINTER (*) to an INT" */

float fvar;
float* fptr;

prt=&a;		/* Load the pointer addresses. Pointers must ALWAYS
				have a valid address stored in them before they
				can be used.*/

fptr=&fvar;

printf("Input an integer -->");
scanf("%d",&a);

printf("\nInput a floating point number -->");
scanf("%f",&fvar);

//
// Pass the pointer values.
// We actually don't need separate pointer variables in this
// program. The declarations for PRT and FPTR could be eliminated
// if the following statement were changed to:
//
// sendit( &a, &fvar );
//

printf("\n\nThe integer A  is now %d ",a);
printf("\n\nThe float FVAR is now %f\n\n",fvar);


sendit(prt,fptr);

printf("\n\nA is now %d ",a);
printf("\n\nFVAR is now %f\n\n",fvar);
}


