
/*                    SORT1.C

	This is an example of a sorted list.  The procedure used is
	a bubble sort.  The items are actually swapped in the sort.
	
	NOTE that this type of sort is much better accomplished by
	using a structure array to hold the data! */


#include <stdio.h>
#include <string.h>
#include <stdlib.h>


#define MAX 50			/* maximum array row subscript value +1 */
char strings[MAX][80];	/* array of 50 x 80, enough for 50 items */
int entries;			/* counter for number of entries */






/* Sort routine.  In a shell sort (the most inefficient sort possible!),
   pairs of consecutive items are compared. If they are not in order,
   a flag is set and the items are swapped.  Then the next pair of
   items is examined (which includes the 2nd item of the first pair as
   the 1st item of the "next" pair.)  A swap flag is maintained; if
   no swaps occurred during a pass of the list of items, the routine
   is finished.  Otherwise, the flag is reset and another pass is
   attempted.  This will continue until all items are in the desired
   order.  

   In this routine, STRCMP is used to compare the two string values.*/


void sort_items()
{
int swap_flag,i,j;	/* flag and indices for counting */
char temp[80];	/* temp string for swapping */

if (entries==0) return;	/* if only one entry, no sort needed ! */

/* begin pass 1 of the list of items. */

do	{
	swap_flag=0;		/* reset swap flag--no swaps have yet occurred. */
	for(i=0,j=1;i<entries;i++,j++)	/* note DOUBLE indices in FOR loop */
				{
				if (strcmp(strings[i],strings[j]) > 0)
									{
									strcpy(temp,strings[j]);
									strcpy(strings[j],strings[i]);
									strcpy(strings[i],temp);
									swap_flag=1;
									}

				}

	}
	while (swap_flag != 0);	/* go back and check again if we swapped
								ANY items.  else we're done. */

}


/* Main program here */


void main()
{
int i;


printf("\n\nThis is an example of a shell or bubble sort.  You are to enter\
 up to 50 items you want sorted.  Press RETURN on a blank line to\
begin the sorting procedure.\n\n");

entries=-1;			/* flag for NO entries */

for(i=0;i<MAX;i++)	{
					printf("Item #%3d : ",i+1);	/* print user PROMPT */
					gets(strings[i]);	/* get each string */

					if (strings[i][0] == 0)	break;	/* bust out if last one*/

					entries++;	/* else, update entry counter & continue */
					}


/* Check for NO entries condition--no need to do anything if so */

if (entries== -1)	return;	/* blast outta here, nothing to do */

printf("\n\nSorting %d entries...",entries+1);

sort_items();	/* call the function to perform the actual sorting. */

printf("done.  Here is the sorted list:\n");

for(i=0;i<=entries;i++)	
				printf("\nItem #%3d : %s",i+1,strings[i]);


printf("\n\nThat's all, folks!\n");

}


