
/*                    SORT3.C

	This is a visual bubble sort.  Up to 50 items are permitted as
	before. Requires: WINDOW.O, INPUT.O, PRINT.O libraries
	
	Sorry, this version is not for Turbo C or Visual C -- it
	is written for an older (pre-ANSI) C compiler. Can you
	make the adjustments needed for it to run? */



#include <stdio.h>


#define LEN 12			/* max string length */
#define MAX 50			/* maximum array row subscript value +1 */
char strings[MAX][LEN];	/* array of 50 x LEN, enough for 50 items */
char pointer[MAX];		/* array of pointers to the STRINGS. Note
							that these aren't really C POINTERS. */
int entries;			/* counter for number of entries */
unsigned int dly;		/* delay between displays; or 0 for key prompt */

main()
{
int i,w1,w2;

/* open windows & init window manager */

exec("","");
if (init_window()== -1)	{
						printf("*** ERROR *** Insufficient memory.\n\n");
						exit(1);
						}

w1=window_open(0,0,79,24,1,7,0);	/* single-line border window */
set_int10_hook(1);	/* make all printf() go to windows */
printf("                  *** VISUAL BUBBLE SORT ***");

w2=window_open(4,4,75,20,2,7,0);

printf("\n\nThis is an example of a shell or bubble sort.\n\
You are to enter up to 50 items you want sorted.\n\
Press RETURN on a blank line to begin the sorting\n\
procedure.\n\n");

entries=-1;			/* flag for NO entries */

printf("How much delay, in mS, between swaps would you like?\n\
Enter 0 if you want system to wait for a key on swap ?");
scanf("%d",&dly);

for(i=0;i<MAX-1;i++)	{
					printf("\nItem #%d : ",i+1);
					getlin(strings[i],LEN-1);

					pointer[i]=i;		/* initial value of each pointer. */

					if (strings[i][0] == 0)	break;

					entries++;
					}

close_window();	/* close data entry window */

/* Check for NO entries condition */

if (entries== -1)	{
					close_all();	/* clear up everything */
					exit();	/* blast outta here, nothing to do */
					}


sort_items();

setcursor_window(0,20);
setattr_window(31);
printf("Done.  Press ENTER to continue");
getlin(strings[1],1);

					{
					close_all();
					exit();
					}

}


/* Sort routine.  A shell sort is used as before.  The only difference
   now is that only POINTER values are exchanged, instead of entire
   strings.  Note that these are not "C" pointers; they are just
   array indices.  The elements are displayed whenever a swap
   occurs. */


void sort_items()
{
int swap_flag,i,j,temp_ptr;

if (entries==0) return;	/* if only one entry, no sort needed ! */

for (i=0;i<=entries;i++) display_elements(i);	/* put up initial list */

do	{
	swap_flag=0;
	for(i=0,j=1;i<entries;i++,j++)
				{
				if (strcmp(strings[pointer[i] ],
								strings[pointer[j] ]) > 0)
									{
									temp_ptr=pointer[i];
									pointer[i]=pointer[j];	/* ptr swap */
									pointer[j]=temp_ptr;
									swap_flag=1;
									display_elements(i);	/* display */
									display_elements(j);

									if (dly)
										delay(dly);
									else wait_key();
									}

				}

	}
	while (swap_flag != 0);
}


/* display the swapped elements @ proper position in display.
   Y position = 2*(element/6) +1, and X=12*(element MOD 6) + 1 */

display_elements(index)
int index;
{
int x,y;

y=2*(index/6) + 2;
x=12*(index % 6) + 1;

setcursor_window(x,y);

printf("           ");

setcursor_window(x,y);

puts_window(strings[pointer[index] ]);

}

