#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <conio.h>

#define CR 0x0d
#define BS 0x08


/* This is a simple input routine designed to input strings in a
   reliable manner. It can also be used indirectly to input other data
   types.

   int getline( char *s , int max)

   s --> The address of a character array to be used as the input buffer.
	 This buffer will be terminated with a 00H pattern on return.

   max --> The maximum number of characters the user will be allowed to
	 type into the buffer pointed by 's.'

   The INT returned by GETLINE is a report of the number of characters
   accepted into the buffer from the user.

		*/

int getline( char *s, int max)
{
int count;		// local count of characters typed
char c;		        // The character just typed

for(count=0;;)
	{
	c=getch();	// Wait for a keystroke from the user

	// Backspace key processing

	if (c==BS)
		{
		if (count==0) continue;	// Can't backspace if nothing is there!
		count--;	// Adjust length counter
		s--;		// Adjust buffer pointer back
		putchar(BS);	// Echo a backspace to the console
		continue;
		}

	// Carriage return processing

	if (c==CR)
		{
		*s = '\0';	// Terminate string with NUL
		putchar('\n');	// Force cursor to new line for user
		return(count);	// Report count of keystrokes
		}

	// Not a carriage return or backspace -- see if we can put it
	// into the input buffer

	if (count>=max)
		{
		putchar('\7');	// Beep -- line too long
		continue;
		}

	// Accept character, store in buffer

	*s = c;			// Store character
	putchar(c);		// Echo the character
	s++;			// Adjust buffer pointer
	count++;		// Adjust character count
	}
}

/*	The following MAIN function is there to exercise the input
	routine. */

void main(void)
{
char buffer[128];	// A place to put some typed information
char field2[40];	// Another place to put more typed information
int len;
int a_value;

printf("Type in something, Homer\n>");
len=getline( buffer, 127);		// Allow 127 characters

printf("\n%s\n\nLength = %d\n\n", buffer, len);

// Fairly solid INTeger input, but clumsy. We'll improve it in class.

printf("Type in an INT numeric value please?");
len=getline(field2,6);	// Get numeric input as a character string
a_value=atoi(field2);	// convert string representation to INT form

// Do some arithmetic to prove that the input really is in INT form
// (we couldn't have done arithmetic directly with a character array string
//

printf("\nThe value %d squared is %d\n",a_value,a_value*a_value);
}

